## dmtcp-2.6.1rc1-4.src.tar.gz

=== manpages/Makefile ===
# This is the version of latex2man of 2017/10/03, with bug fixes from the author
# Since this will be invoked only by developers, delete local latex2man
#   when the author's version makes its way into our current distro.
LATEX2MAN=./latex2man
hdr=header.tex
ftr=footer.tex
macros=macros.trans
tmp=tmp.tex
vtmp=vtmp.tex

targets = dmtcp_command dmtcp_coordinator dmtcp_launch dmtcp_restart dmtcp_srun_helper

default:
	echo "\setVersion{`cat ../VERSION`}" > $(vtmp)
	echo "\setDate{`date +"%B, %Y"`}" >> $(vtmp)
	for i in $(targets); do \
	  (cat $(hdr) $(vtmp) $$i.latex2man $(ftr) > $(tmp) && \
	   ${LATEX2MAN} -t $(macros) $(tmp) $$i.1) && gzip -f $$i.1; \
	done
	rm $(vtmp) $(tmp)

html-manpages:
	echo "\setVersion{`cat ../VERSION`}" > $(vtmp)
	echo "\setDate{`date +"%B, %Y"`}" >> $(vtmp)
	for i in $(targets); do \
	  (cat $(hdr) $(vtmp) $$i.latex2man $(ftr) > $(tmp) && \
	   ${LATEX2MAN} -H -t $(macros) $(tmp) $$i.html); \
	done
	rm $(vtmp) $(tmp)

latex-manpages:
	echo "\setVersion{`cat ../VERSION`}" > $(vtmp)
	echo "\setDate{`date +"%B, %Y"`}" >> $(vtmp)
	for i in $(targets); do \
	  (cat $(hdr) $(vtmp) $$i.latex2man $(ftr) > $(tmp) && \
	   ${LATEX2MAN} -L $(tmp) $$i.tex) && \
	   echo '\\end{document}' >> $$i.tex; \
	done
	rm $(vtmp) $(tmp)

clean:
	for i in $(targets); do \
	  rm -f $$i.tex $$i.html; \
	done

distclean: clean
	for i in $(targets); do \
	  rm -f $$i.1.gz; \
	done

.PHONY: default clean distclean

=== contrib/apache/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting library will have this name.
LIBNAME=dmtcp_${NAME}hijack

# As you add new files to your hijack library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../..
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/include

CFLAGS += -I${DMTCP_INCLUDE} -DDMTCP -fPIC -c -g
CXXFLAGS += -I${DMTCP_INCLUDE} -DDMTCP -fPIC -c -g

DEMO_PORT=7781

default: ${LIBNAME}.so

${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
check: ${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1
	# Note that full path of plugin (using $$PWD in this case) is required.
	${DMTCP_ROOT}/bin/dmtcp_launch --port ${DEMO_PORT} -i 5 \
	  --with-plugin $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1

# We link the library using C++ for compatibility with the main libdmtcp.so
${LIBNAME}.so: ${LIBOBJS}
	${CXX} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean:
	rm -f ${LIBOBJS} ${LIBNAME}.so

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== contrib/ckpttimer/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting library will have this name.
LIBNAME=dmtcp_${NAME}

# As you add new files to your hijack library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/include
JALIB_INCLUDE=${DMTCP_ROOT}/jalib/

CFLAGS += -I${DMTCP_INCLUDE} -I${JALIB_INCLUDE} -DDMTCP -fPIC -c --std=gnu99 -g -O0
CXXFLAGS += -I${DMTCP_INCLUDE} -I${JALIB_INCLUDE} -DDMTCP -fPIC -c -g -O0

# enable this for debugging the plugin
# CFLAGS += -DCKPTTIMER_PLUGIN_DEBUG
# CXXFLAGS += -DCKPTTIMER_PLUGIN_DEBUG

DEMO_PORT=7781

default: ${LIBNAME}.so

${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
check: ${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1
	# Note that full path of plugin (using $$PWD in this case) is required.
	${DMTCP_ROOT}/bin/dmtcp_launch --port ${DEMO_PORT} -i 5 \
	  --with-plugin $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1

# We link the library using C++ for compatibility with the main libdmtcp.so
${LIBNAME}.so: ${LIBOBJS}
	${CXX} -shared -fPIC -o $@ $^ -lrt

.c.o:
	${CC} ${CFLAGS} -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean:
	rm -f ${LIBOBJS} ${LIBNAME}.so

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== contrib/kvm/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting library will have this name.
LIBNAME=dmtcp_${NAME}hijack

# As you add new files to your hijack library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../..
endif
DMTCP_SRC=${DMTCP_ROOT}/dmtcp/src
DMTCP_INCLUDE=${DMTCP_ROOT}/dmtcp/include

CFLAGS += -I${DMTCP_INCLUDE} -DDMTCP -fPIC -c -g
CXXFLAGS += -I${DMTCP_INCLUDE} -DDMTCP -fPIC -c -g

DEMO_PORT=7781

default: ${LIBNAME}.so

${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
check: ${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1
	${DMTCP_ROOT}/bin/dmtcp_launch --port ${DEMO_PORT} -i 5 \
	  --with-plugin $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1

# We link the library using C++ for compatibility with the main dmtcphijack.so
${LIBNAME}.so: ${LIBOBJS}
	${CXX} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean:
	rm -f ${LIBOBJS} ${LIBNAME}.so

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== contrib/tun/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting library will have this name.
LIBNAME=dmtcp_${NAME}hijack

# As you add new files to your hijack library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/dmtcp/include

CFLAGS += -I${DMTCP_INCLUDE} -DDMTCP -fPIC -c -g
CXXFLAGS += -I${DMTCP_INCLUDE} -DDMTCP -fPIC -c -g

DEMO_PORT=7781

default: ${LIBNAME}.so

${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
check: ${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1
	${DMTCP_ROOT}/bin/dmtcp_launch --port ${DEMO_PORT} -i 5 \
	  --with-plugin $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1

# We link the library using C++ for compatibility with the main libdmtcp.so
${LIBNAME}.so: ${LIBOBJS}
	${CXX} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean:
	rm -f ${LIBOBJS} ${LIBNAME}.so

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== doc/src/Makefile ===
# This Makefile was used to produce .pdf files from .tex files.

FIG=${wildcard *.fig}
EPS=${FIG:.fig=.eps}

plugin-tutorial.pdf: plugin-tutorial.tex
	pdflatex $<
	if grep -q Rerun `basename $< .tex`.log; then pdflatex $<; fi

architecture-of-dmtcp.pdf: architecture-of-dmtcp.ps
	ps2pdf $<
architecture-of-dmtcp.ps: architecture-of-dmtcp.dvi
	dvips $<
architecture-of-dmtcp.dvi: architecture-of-dmtcp.tex ${EPS}
	latex $<

%.eps: %.fig
	fig2dev -L eps $< > $@

clean:
	rm -rf *.eps *.dvi *.ps *.pdf *.aux *.log *.toc *.out

=== test/plugin/applic-delayed-ckpt/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting plugin library will have this name.
LIBNAME=libdmtcp_plugin-to-announce-events

# As you add new files to your plugin library, add the object file names here.
LIBOBJS = plugin-to-announce-events.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/include

override CFLAGS += -I${DMTCP_INCLUDE}
override CXXFLAGS += -I${DMTCP_INCLUDE}
LINK = ${CC}

DEMO_PORT=7781

default: ${LIBNAME}.so applic

# NOTE:  ${CFLAGS} expands to invoke '-fPIC -I${DMTCP_INCLUDE}'
#        This is required for use with DMTCP.
applic: applic.c
	${CC} -fPIC ${CFLAGS} -o $@ $<

check: ${LIBNAME}.so applic
	@ echo ""
	@ echo "============ TESTING ./applic _WITHOUT_ DMTCP ================"
	- ./applic
	@ echo '(Application has exited.)'
	@ echo ""
	@ sleep 3
	@ echo "============ TESTING ./applic WITH DMTCP ================="
	# Kill an old coordinator on this port if present, just in case.
	@ ${DMTCP_ROOT}/bin/dmtcp_command --quit --quiet \
	  --coord-port ${DEMO_PORT} 2>/dev/null || true
	# --interval 2 flag will write checkpoint every two seconds.
	${DMTCP_ROOT}/bin/dmtcp_launch --quiet --coord-port ${DEMO_PORT} \
	  --interval 2 --with-plugin $$PWD/${LIBNAME}.so ./applic &
	@ sleep 7
	@ echo ""
	@ ${DMTCP_ROOT}/bin/dmtcp_command --coord-port ${DEMO_PORT} -s || echo "NO COORDINATOR"
	@ echo "===== RESTARTING USING ./dmtcp_restart_script.sh ============="
	./dmtcp_restart_script.sh
	@ echo ""
	@ echo "ALL TESTS SUCCEEDED"

${LIBNAME}.so: ${LIBOBJS}
	${LINK} -shared -fPIC -o $@ $^

${LIBOBJS}: plugin-to-announce-events.c
	${CC} -fPIC ${CFLAGS} -c -o $@ $<
.c.o:
	${CC} ${CFLAGS} -c -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -c -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean: tidy
	rm -f ${LIBOBJS} ${LIBNAME}.so applic

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== test/plugin/applic-initiated-ckpt/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting plugin library will have this name.
LIBNAME=libdmtcp_plugin-to-announce-events

# As you add new files to your plugin library, add the object file names here.
LIBOBJS = plugin-to-announce-events.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/include

override CFLAGS += -I${DMTCP_INCLUDE}
override CXXFLAGS += -I${DMTCP_INCLUDE}
LINK = ${CC}

DEMO_PORT=7781

default: ${LIBNAME}.so applic

# NOTE:  ${CFLAGS} expands to invoke '-fPIC -I${DMTCP_INCLUDE}'
#        This is required for use with DMTCP.
applic: applic.c
	${CC} -fPIC ${CFLAGS} -o $@ $<

check: ${LIBNAME}.so applic
	@ echo ""
	@ echo "============ TESTING ./applic _WITHOUT_ DMTCP ================"
	- ./applic
	@ echo '(Application has exited.)'
	@ echo ""
	@ sleep 3
	@ echo "============ TESTING ./applic WITH DMTCP ================="
	# Kill an old coordinator on this port if present, just in case.
	@ ${DMTCP_ROOT}/bin/dmtcp_command --quit --quiet \
	  --coord-port ${DEMO_PORT} 2>/dev/null || true
	${DMTCP_ROOT}/bin/dmtcp_launch --quiet --coord-port ${DEMO_PORT} \
	  --with-plugin $$PWD/${LIBNAME}.so ./applic
	@ echo ""
	@ sleep 5
	@ echo "===== RESTARTING USING ./dmtcp_restart_script.sh ============="
	./dmtcp_restart_script.sh
	@ echo ""
	@ echo "ALL TESTS SUCCEEDED"

${LIBNAME}.so: ${LIBOBJS}
	${LINK} -shared -fPIC -o $@ $^

${LIBOBJS}: plugin-to-announce-events.c
	${CC} -fPIC ${CFLAGS} -c -o $@ $<
.c.o:
	${CC} ${CFLAGS} -c -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -c -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean: tidy
	rm -f ${LIBOBJS} ${LIBNAME}.so applic

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== test/plugin/example-db/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting plugin library will have this name.
LIBNAME=libdmtcp_${NAME}

# As you add new files to your plugin library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/include

override CFLAGS += -fPIC -I${DMTCP_INCLUDE}
override CXXFLAGS += -fPIC -I${DMTCP_INCLUDE}
LINK = ${CC}

DEMO_PORT=7781

default: ${LIBNAME}.so

# We run two processes, dmtcp1, with keys set to 1 for one, and 2 for the other
${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
check: ${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1
	# Kill an old coordinator on this port if present, just in case.
	@ ${DMTCP_ROOT}/bin/dmtcp_command --quit --quiet \
	  --coord-port ${DEMO_PORT} 2>/dev/null || true
	# Begin test
	${DMTCP_ROOT}/bin/dmtcp_coordinator --coord-port ${DEMO_PORT} \
	  --daemon --exit-on-last -i 5
	EXAMPLE_DB_KEY=1 EXAMPLE_DB_KEY_OTHER=2 \
	  ${DMTCP_ROOT}/bin/dmtcp_launch --coord-port ${DEMO_PORT} --join -i 5\
	  --with-plugin $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1 &
	EXAMPLE_DB_KEY=2 EXAMPLE_DB_KEY_OTHER=1 \
	  ${DMTCP_ROOT}/bin/dmtcp_launch --coord-port ${DEMO_PORT} --join -i 5\
	  --with-plugin $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1 &
	sleep 20; ${DMTCP_ROOT}/bin/dmtcp_command --coord-port ${DEMO_PORT} --quit

${LIBNAME}.so: ${LIBOBJS}
	${LINK} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -c -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -c -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean: tidy
	rm -f ${LIBOBJS} ${LIBNAME}.so

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== test/plugin/example/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting plugin library will have this name.
LIBNAME=libdmtcp_${NAME}

# As you add new files to your plugin library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/include

override CFLAGS += -fPIC -I${DMTCP_INCLUDE}
override CXXFLAGS += -fPIC -I${DMTCP_INCLUDE}
LINK = ${CC}

DEMO_PORT=7781

default: ${LIBNAME}.so

${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
check: ${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1
	# Kill an old coordinator on this port if present, just in case.
	@ ${DMTCP_ROOT}/bin/dmtcp_command --quit --quiet \
	  --coord-port ${DEMO_PORT} 2>/dev/null || true
	# Note that full path of plugin (using $$PWD in this case) is required.
	${DMTCP_ROOT}/bin/dmtcp_launch --coord-port ${DEMO_PORT} --interval 5 \
	  --with-plugin $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1

${LIBNAME}.so: ${LIBOBJS}
	${LINK} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -c -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -c -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean: tidy
	rm -f ${LIBOBJS} ${LIBNAME}.so

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== test/plugin/sleep1/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting plugin library will have this name.
LIBNAME=libdmtcp_${NAME}

# As you add new files to your plugin library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/include

override CFLAGS += -fPIC -I${DMTCP_INCLUDE}
override CXXFLAGS += -fPIC -I${DMTCP_INCLUDE}
LINK = ${CC}

DEMO_PORT=7781

default: ${LIBNAME}.so

${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
check: ${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1
	# Kill an old coordinator on this port if present, just in case.
	@ ${DMTCP_ROOT}/bin/dmtcp_command --quit --quiet \
	  --coord-port ${DEMO_PORT} 2>/dev/null || true
	${DMTCP_ROOT}/bin/dmtcp_launch --coord-port ${DEMO_PORT} --interval 5 \
	  --with-plugin $$PWD/${LIBNAME}.so ${DMTCP_ROOT}/test/dmtcp1

${LIBNAME}.so: ${LIBOBJS}
	${LINK} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -c -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -c -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean: tidy
	rm -f ${LIBOBJS} ${LIBNAME}.so

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== test/plugin/sleep2/Makefile ===
# MOST Makefile's IN ../plugin/* ARE IDENTICAL.  THIS ONE IS SLIGHTLY ALTERED.
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting plugin library will have this name.
LIBNAME=libdmtcp_${NAME}

# As you add new files to your plugin library, add the object file names here.
LIBOBJS = ${NAME}.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/include

override CFLAGS += -fPIC -I${DMTCP_INCLUDE}
override CXXFLAGS += -fPIC -I${DMTCP_INCLUDE}
LINK = ${CC}

DEMO_PORT=7781

default: ${LIBNAME}.so

${DMTCP_ROOT}/test/dmtcp1: ${DMTCP_ROOT}/test
	cd ${DMTCP_ROOT}/test; make dmtcp1
../sleep1/libdmtcp_sleep1.so: ../sleep1
	cd ../sleep1; make libdmtcp_sleep1.so
check: ${LIBNAME}.so ../sleep1/libdmtcp_sleep1.so ${DMTCP_ROOT}/test/dmtcp1
	# Kill an old coordinator on this port if present, just in case.
	@ ${DMTCP_ROOT}/bin/dmtcp_command --quit --quiet \
	  --coord-port ${DEMO_PORT} 2>/dev/null || true
	${DMTCP_ROOT}/bin/dmtcp_launch --coord-port ${DEMO_PORT} --interval 5 \
	  --with-plugin \
		$$PWD/../sleep1/libdmtcp_sleep1.so:$$PWD/${LIBNAME}.so \
	  ${DMTCP_ROOT}/test/dmtcp1

${LIBNAME}.so: ${LIBOBJS}
	${LINK} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -c -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -c -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean: tidy
	rm -f ${LIBOBJS} ${LIBNAME}.so

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== debian/changelog ===
dmtcp (2.6.0-2) unstable; urgency=low
  
  * Does not include i386 or armhf or aarch64.
  * This is a source-only package.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Paul Grosu <pgrosu@gmail.com>  Tue Sep 10 17:47:11 EDT 2019 -0400

dmtcp (2.6.0-1) unstable; urgency=low

  * New upstream release. (Closes: #791940)
  * Boosted the debian/compat for debhelper to 10.
  * Added manpage of dmtcp_srun_helper.
  * Compiled binaries with position-independent executable flag.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Paul Grosu <pgrosu@gmail.com>  Thu, 4 Jul 2019 23:00:00 -0400

dmtcp (2.3.1-5) unstable; urgency=low

  * Removed armhf architecture support from dmtcp-dbg as well.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 26 Jul 2014 09:58:35 -0400

dmtcp (2.3.1-4) unstable; urgency=low

  * Removed armel architecture support.
  * Remove previously added -march=armv7 for ARM builds.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Fri, 25 Jul 2014 16:19:26 -0400

dmtcp (2.3.1-3) unstable; urgency=low

  * Added armhf architecture support.
  * Force -march=armv7 for ARM builds.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Thu, 24 Jul 2014 11:50:36 -0400

dmtcp (2.3.1-2) unstable; urgency=low

  * Compilation fix for older ARM CPUs.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 19 Jul 2014 13:42:49 -0400

dmtcp (2.3.1-1) unstable; urgency=low

  * New upstream release 2.3.1 (closes: #662910).
  * Remove stale dependency on libmtcp1 (closes: #753764).
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Mon, 14 Jul 2014 18:56:41 -0400

dmtcp (2.2-1) unstable; urgency=low

  * New upstream release 2.2.
  * Changing distribution from experimental to unstable.
  * Updated debian standards version to 3.9.5.
  * Removed libmtcp and libdmtcpaware packages.
  * Run make check in "slow" mode.
  * Updated copyright file.
  * Added debian/NEWS file.
  * Removed some stale files from install procedure.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 11 Jan 2014 23:47:45 -0500

dmtcp (1.2.7-1) experimental; urgency=low

  * Preparing for upstream Release 1.2.7.
  * Vcs-svn and Vcs-browser URLs updated.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Thu, 14 Mar 2013 07:10:34 -0400

dmtcp (1.2.5-1) unstable; urgency=low

  * Preparing for upstream Release 1.2.5.
  * debhelper version changed from >=9 to >=7 to accommodate older distros.
  * Standards version changed to 3.9.3. 
  * configure command line updated to include dkpg-buildflags.
  * Added lintian overrides for libmtcp1, dmtcp and libdmtcpaware1 to suppress
    hardening false positives.
  * ARM support added.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 26 May 2012 22:54:33 -0400

dmtcp (1.2.4-1) unstable; urgency=low

  * Preparing for upstream Release 1.2.4.
  * New binary packages libmtcp1 and libmtcp1-dev created.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Mon, 24 Jan 2012 17:00:11 -0500

dmtcp (1.2.1-2) unstable; urgency=low

  * Fixing compilation errors for gcc/g++ 4.6.
  * Fixing compilation errors related to PAGE_SIZE and PAGE_MASK macros.
  * Call "make check" towards the end of build-stamp.
  * Add python to build-deps.
  * Standards Version boosted to 3.9.2.
  * Templates removed from debian/watch.
  * Leading "./" removed from lintian-overrides.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Tue, 31 May 2011 00:17:42 -0400

dmtcp (1.2.1-1) unstable; urgency=low

  * Preparing for upstream release 1.2.1. 

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 12 Mar 2011 17:41:11 -0500

dmtcp (1.2.0+svn937-1) unstable; urgency=low

  * Updating libdmtcpaware1.symbols to reflect the proper version.
  * Updating watch file to point to proper package name

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 12 Mar 2011 17:10:02 -0500

dmtcp (1.2.0+svn923-1) unstable; urgency=low

  * Adding debian/libdmtcpaware1.symbols file.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Wed, 09 Mar 2011 02:03:21 -0500

dmtcp (1.2.0+svn876-1) unstable; urgency=low

  * Initial release (Closes: #610653)
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Thu, 03 Feb 2011 09:52:24 -0500

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>

pkgname=dmtcp
pkgver=2.6.1rc1
pkgrel=4
pkgdesc='Distributed MultiThreaded CheckPointing'
url='http://dmtcp.sourceforge.net'
arch=('x86_64')
license=('LGPL')
depends=('bash' 'gcc-libs' 'glibc')
makedepends=('dash' 'emacs' 'gdb' 'java-environment' 'openmpi' 'procps-ng'
'python' 'screen' 'strace' 'tcsh' 'vim' 'zsh')
source=("https://downloads.sourceforge.net/project/$pkgname/${pkgver/rc*}/$pkgname-${pkgver/rc/~rc}.tar.gz")
sha256sums=('284c281b561a7518ee6eb0561baeca1fe33034e368c7a05bc3dcb9ffa434778d')
b2sums=('6cbec14ee94b251717b237d7ed6a7f4047997eec222b0ffb3d85384b319df5384b2fe0454f731824b07391ff2162219060448b934f0308c70c755bbed1268208')

build() {
  cd $pkgname-${pkgver/rc/~rc}
  ./configure \
    --prefix=/usr \
    --sysconfdir=/etc
  make
}

package() {
  make DESTDIR="$pkgdir" install -C $pkgname-${pkgver/rc/~rc}
}

=== debian/control ===
Source: dmtcp
Section: utils
Priority: optional
Maintainer: Paul Grosu <pgrosu@gmail.com>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Kapil Arya <kapil@ccs.neu.edu>
Build-Depends: debhelper (>= 11), python
Standards-Version: 4.2.1
Vcs-git: https://github.com/dmtcp/dmtcp.git
Vcs-browser: https://github.com/dmtcp/dmtcp
Homepage: http://dmtcp.sourceforge.net

# Later, we want to go back and support i386 for Debian.
Package: dmtcp
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Checkpoint/Restart functionality for Linux processes
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to
 transparently checkpointing the state of an arbitrary group of
 applications including multi-threaded and distributed computations.
 It operates directly on the user binary executable, with no Linux kernel
 modules or other kernel mods.
 .
 Among the applications supported by DMTCP are Open MPI, MVAPICH2, MATLAB,
 R, Python, Perl, and many programming languages and shell scripting
 languages.  It supports both TCP sockets and InfiniBand connections.
 With the use of TightVNC, it can also checkpoint and restart X-Window
 applications.  The OpenGL library for 3D graphics is supported through
 a special plugin.
 .
 This package contains DMTCP binaries.

# Later, we want to go back and support i386 for Debian.
Package: dmtcp-dbg
Architecture: amd64
Section: debug
Priority: optional
Depends: dmtcp, ${misc:Depends}
Description: Debug package for dmtcp
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to
 transparently checkpointing the state of an arbitrary group of
 applications including multi-threaded and distributed computations.
 It operates directly on the user binary executable, with no Linux kernel
 modules or other kernel mods.
 .
 Among the applications supported by DMTCP are Open MPI, MVAPICH2, MATLAB,
 R, Python, Perl, and many programming languages and shell scripting
 languages.  It supports both TCP sockets and InfiniBand connections.
 With the use of TightVNC, it can also checkpoint and restart X-Window
 applications.  The OpenGL library for 3D graphics is supported through
 a special plugin.
 .
 This package contains debugging symbols for DMTCP.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

DPKG_BUILD_VERSION= $(shell dpkg-buildflags --version | sed -ne '1s,.*version *,,gp')
ifeq ($(shell dpkg --compare-versions 1.16.1 lt $(DPKG_BUILD_VERSION) && echo TRUE), TRUE)
DPKG_BUILDFLAGS= $(shell dpkg-buildflags --export=configure)
else
DPKG_BUILDFLAGS= CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS) -pie" LDFLAGS="-Wl,-z,defs"
endif

BUILDDIR = debian/tmp
DESTDIR = $(CURDIR)/$(BUILDDIR)


configure: configure-stamp
configure-stamp:
	dh_testdir
	./configure $(CROSS) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info $(DPKG_BUILDFLAGS)

	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure-stamp  
	dh_testdir

	$(MAKE)
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
ifneq ($(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU),arm)
	env PWD=`pwd` ./test/autotest.py
endif
endif
	#$(MAKE) check

	touch $@

clean: 
	dh_testdir
	rm -f build-stamp configure-stamp

	[ ! -f Makefile ] || $(MAKE) distclean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep  
	dh_installdirs
	dh_lintian

	# Add here commands to install the package into debian/dmtcp.
	$(MAKE) DESTDIR=$(DESTDIR) install

	# For compat 10
	dh_install -XCOPYING --fail-missing --sourcedir=$(BUILDDIR)

	# For compat 12 (We tried this:):
	#dh_install -XCOPYING --list-missing --sourcedir=$(BUILDDIR)
	#dh_missing -XCOPYING --fail-missing --sourcedir=$(BUILDDIR)
	# (And if fails with:)
	## # For compat 12
	## dh_install -XCOPYING --list-missing --sourcedir=debian/tmp
	## dh_install: Please use dh_missing --list-missing/--fail-missing instead
	## dh_install: This feature was removed in compat 12.
	## debian/rules:67: recipe for target 'install' failed
	## make: *** [install] Error 25
	## dpkg-buildpackage: error: fakeroot debian/rules binary subprocess returned exit status 2


# Build architecture-independent files here.
binary-indep: install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_link
	dh_strip --dbg-package=dmtcp-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/dmtcp-$1\.tar\.gz/ \
  https://github.com/dmtcp/dmtcp/tags .*/v?(\d\S*)\.tar\.gz
